/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
 
var heartRateServiceUuid = "1814";
var heartRateMeasurementCharacteristicUuid = "2a53";
var clientCharacteristicConfigDescriptorUuid = "2a56";
    
var app = {
	devices:[],
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
        console.log(ble);
        ble.isEnabled(
			function() {
				$('#text').append("<p>Bluetooth is enabled</p>");
				app.refreshDeviceList();
			},
			function() {
				$('#text').append("<p>Bluetooth is *not* enabled</p>");
				ble.enable(
					function(){
						$('#text').append("<p>Could enable Bluetooth</p>");
						app.onDeviceReady()
					}, function(){
						$('#text').append("<p>Could *not* enable Bluetooth</p>");
						app.exit();
					}
				);
			}
		);
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        console.log('Received Event: ' + id);
    },
    refreshDeviceList: function() {
		$('#text').append("<p>Scanning 5 seconds for devices</p>");
        // scan for all devices
        ble.scan([], 5, app.onDiscoverDevice, app.scanError);
        setTimeout( $.proxy(app.connectDevice, app), 6000);
    },
    onDiscoverDevice: function(device) {
		$('#text').append("<p>Device discovered</p>");
        console.log(JSON.stringify(device));
        var listItem = document.createElement('li'),
            html = '<b>' + device.name + '</b><br/>' +
                'RSSI: ' + device.rssi + '&nbsp;|&nbsp;' +
                device.id;

        listItem.dataset.deviceId = device.id;  // TODO
        listItem.innerHTML = html;
        $('#text').append(listItem);
        if(device.name == "BLE-VoltageCheck"){
			$('#text').append("<p>BatteryGuardDevice discovered</p>");
			app.devices.push({id:device.id});
			$('#text').append("<p>Add device to store</p>");
		}

    },
    scanError: function(id) {
        $('#text').append("<p>Scan error</p>");
    },
    connectDevice: function() {
		$('#text').append("<p>Connect device</p>");
		if(this.devices.length){
			$('#text').append("<p>Try to connect to device "+this.devices[0].id+"</p>");
			ble.connect(this.devices[0].id, app.onConnect, app.onError);
		}
    },
    onConnect:function(peripheralData){
		$('#text').append("<p>Connected to "+peripheralData.id+"</p>");
		$('#text').append(JSON.stringify(peripheralData));
		ble.startNotification(peripheralData.id, "1814", "2a53", app.notificationSuccess, app.notificationFailure);
	},
	notificationSuccess:function(rawData){
		if ((flag & 0x01) == 1){

            var u16 = new Uint16Array(rawData);
            hr = u16;
		}
		else{

            var u8 = new Uint8Array(rawData);
            hr = u8;
		}
		
		var data = new DataView(rawData);
		$('#text').append('dataViewlength:'+data.byteLength);
		
		
		var u8 = new Uint8Array(rawData);
		var u16 = new Uint16Array(rawData);
		//$('#volts').html('<p>0:'+u8[0]+'</p><p>1:'+u8[1]+'</p><p>u8 2:'+u8[2]+'</p><p>u8 3:'+u8[3]+'</p><p>u8 4:'+u8[4]+'</p><p>5:'+u8[5]+'</p><p>6:'+u8[6]+'</p><p>7:'+u8[7]+'</p><p>8:'+u8[8]+'</p><p>u16 3:'+u16[4]+'</p><p>u8 5:'+u8[5]+'</p><p>9:'+u8[9]+'</p>');
		//$('#volts').html('<p>Flag:'+((flag & 0x01) == 1)+'</p>');
		$('#volts').html('<p>Flag:'+(hr.length)+'</p><p>Volt:'+hr[0]+'|'+hr[1]+'|'+hr[2]+'|'+hr[3]+'|'+hr[4]+'|'+hr[5]+'|'+hr[6]+'|'+hr[7]+'|'+hr[8]+'|'+hr[9]+'|</p>');
		
		

		return;
		
		
		var data = rawData;
		var bytes = new Uint8Array(data.length);
		$('#text').append("<p>length:"+rawData.length+"</p>");
		for (var i = 0; i < rawData.length; i++){
		  bytes[i] = rawData.charCodeAt(i);
		  $('#text').append("<p>Byte"+i+":"+bytes[i]+"</p>");
		}
		return;
		
		
		var flag = bytes[0];

		//Check if u8 or u16 and get heart rate
		var hr;
		if ((flag & 0x01) == 1){
			var u16bytes = bytes.slice(1, 3);
			var u16 = new Uint16Array(u16bytes)[0];
			hr = u16;
		}
		else{
			var u8bytes = rawData.slice(1, 2);
			var u8 = new Uint8Array(u8bytes)[0];
			hr = u8;
		}

		var hr2 = hr/1000;
		
		var data = new DataView(rawData);
		
		$('#text').append(data);
		$('#text').append("<p>dataview:"+data+"</p>");
		$('#text').append("<p>Volt:"+hr2+"</p>");
	},
	notificationFailure:function(){
		$('#text').append("<p>Notification failure</p>");
	},
    onError:function(){
		$('#text').append("<p>Error</p>");
	},
    exit: function(id) {
        $('#text').append("<p>Exit</p>");
    }
};

app.initialize();

window.onerror = function(message, url, lineNumber) {
	$('#text').append("Error: "+message+" in "+url+" at line "+lineNumber);
}
